/*

    this source file is a part of 
    lp_parse - a preprocessor for MILP models
    Copyright (C) 1996  Ari Jolma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    for more information please contact 
    Ari Jolma
    Helsinki University of Technology
    Laboratory of Water Resources Engineering
    Building W
    02150 Espoo, Finland
    E-mail: Ari.Jolma@hut.fi

 */

#define LP_WHITESPACE " \t\r\n@"

/* scans the closing bracket, returns NULL if finds '\0' before it */
char *scan_end_of_braces(char *s); 

double calculate(double x1, char op, double x2); 

void reduce(double *x, char *op); 

/*char *mystrtok(char *s, char *separators, char *buf, int buf_size);*/
	  
int ParseAndEvaluateArithmeticExpression(char **s, CONSTANT *C, INDEX *I, 
					 double *value); 

char *AddIndex(char *name, int index);

int StripIndexes(char **s, char *buf, int buf_size, int *indexes, int *n);

char *ParseSymbol(char **s, CONSTANT *C, INDEX *I); 
	  
int ParseAndEvaluateSymbol(char **s, CONSTANT *C, INDEX *I, double *value);

int ParseMinAndMax(char **s, CONSTANT *C, INDEX *I, int *min, int *max); 

INDEX *ParseIndexDeclaration(char **s, CONSTANT *C, INDEX *I); 

int INDEXListToMin2(CONSTANT *C, INDEX *I, int n);
int IsIndexListLoop(INDEX *I, int n);
int LoopINDEXList2(CONSTANT *C, INDEX *I, int n);

/* parse and add to NewC */
int ParseConstantDeclaration(char **s, CONSTANT *C, INDEX *I, CONSTANT **NewC);

/* parse and add to NewI, returns in n the number of indexes parsed */
int ParseIndexListInFunction(char **s, CONSTANT *C, 
			     INDEX *I, INDEX **NewI, int *n);
